

<!DOCTYPE html>



<head>
    <meta charset="utf-8" />
    <meta name="author" content="Apple Inc." />
    <meta name="viewport" content="width=device-width initial-scale=1" />
    
    <title>About the Language Reference &mdash; The Swift Programming Language (Swift 4.2)</title>
    
    <link rel="license" href="https://docs.swift.org/LICENSE.txt" />
    <link rel="stylesheet" media="all" href="../_static/stylesheets/application.css" />
    <link rel="stylesheet" media="all" href="../_static/stylesheets/tspl.css" />
    <link rel="shortcut icon" sizes="16x16 24x24 32x32 48x48 64x64" type="image/vnd.microsoft.icon" href="../../favicon.ico" />
    <link rel="apple-touch-icon" href="https://docs.swift.org/apple-touch-icon.png" />
    <link rel="apple-touch-icon" sizes="57x57" href="https://docs.swift.org/apple-touch-icon-57x57.png" />
    <link rel="apple-touch-icon" sizes="72x72" href="https://docs.swift.org/apple-touch-icon-72x72.png" />
    <link rel="apple-touch-icon" sizes="76x76" href="https://docs.swift.org/apple-touch-icon-76x76.png" />
    <link rel="apple-touch-icon" sizes="114x114" href="https://docs.swift.org/apple-touch-icon-114x114.png" />
    <link rel="apple-touch-icon" sizes="120x120" href="https://docs.swift.org/apple-touch-icon-120x120.png" />
    <link rel="apple-touch-icon" sizes="144x144" href="https://docs.swift.org/apple-touch-icon-144x144.png" />
    <link rel="apple-touch-icon" sizes="152x152" href="https://docs.swift.org/apple-touch-icon-152x152.png" />
    <link rel="apple-touch-icon" sizes="180x180" href="https://docs.swift.org/apple-touch-icon-180x180.png" />
    <link rel="mask-icon" href="https://docs.swift.org/assets/images/icon-swift.svg" color="#F05339" /> 
  </head>
  <body>


<nav role="navigation">
    <header role="banner">
      <h1 id="logo">
        <a href="https://swift.org/" title="Swift.org" role="img" aria-label="Swift.org">
          Swift.org
        </a>
      </h1>
    </header>

    <div id="menu-toggle" class="menu-toggle open"></div>

    <h2>The Swift Programming Language<div>Swift 4.2</div></h2>

    <ul>
    <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../index.html">Welcome to Swift</a></li>
<li class="toctree-l1"><a class="reference internal" href="../LanguageGuide/TheBasics.html">Language Guide</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="AboutTheLanguageReference.html">Language Reference</a><ul class="current">
<li class="toctree-l2 current"><a class="current reference internal" href="AboutTheLanguageReference.html#">About the Language Reference</a></li>
<li class="toctree-l2"><a class="reference internal" href="LexicalStructure.html">Lexical Structure</a></li>
<li class="toctree-l2"><a class="reference internal" href="Types.html">Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="Expressions.html">Expressions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Statements.html">Statements</a></li>
<li class="toctree-l2"><a class="reference internal" href="Declarations.html">Declarations</a></li>
<li class="toctree-l2"><a class="reference internal" href="Attributes.html">Attributes</a></li>
<li class="toctree-l2"><a class="reference internal" href="Patterns.html">Patterns</a></li>
<li class="toctree-l2"><a class="reference internal" href="GenericParametersAndArguments.html">Generic Parameters and Arguments</a></li>
<li class="toctree-l2"><a class="reference internal" href="zzSummaryOfTheGrammar.html">Summary of the Grammar</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../RevisionHistory/RevisionHistory.html">Revision History</a></li>
</ul>

    <li class="toctree-l1 return"><a class="reference internal" href="https://swift.org/">← Return to Swift.org</a></li>
    </ul>
</nav>




<main role="main">
    <article class="page">
        <menu id="bashful" type="toolbar">
          <div class="inner">
            <menuitem id="jump_to" class="menu-bar-item closed">
            <span id="jump_to_toggle">On This Page</span>
            <div class="chevron">
                <div class="chevy chevron-left"></div>
                <div class="chevy chevron-right"></div>
            </div>
            <menu type="list" class="details">
                <ul>
<li><a class="reference internal" href="AboutTheLanguageReference.html#">About the Language Reference</a><ul>
<li><a class="reference internal" href="AboutTheLanguageReference.html#ID346">How to Read the Grammar</a></li>
</ul>
</li>
</ul>

            </menu>
            </menuitem>
          </div>
        </menu>

        
  <div class="section" id="about-the-language-reference">
<h1>About the Language Reference<a class="headerlink" href="AboutTheLanguageReference.html#about-the-language-reference" title="Permalink to this headline"></a></h1>
<p>This part of the book describes the formal grammar of the Swift programming language. The grammar described here is intended to help you understand the language in more detail, rather than to allow you to directly implement a parser or compiler.</p>
<p>The Swift language is relatively small, because many common types, functions, and operators that appear virtually everywhere in Swift code are actually defined in the Swift standard library. Although these types, functions, and operators are not part of the Swift language itself, they are used extensively in the discussions and code examples in this part of the book.</p>
<div class="section" id="ID346">
<h2>How to Read the Grammar<a class="headerlink" href="AboutTheLanguageReference.html#ID346" title="Permalink to this headline"></a></h2>
<p>The notation used to describe the formal grammar of the Swift programming language follows a few conventions:</p>
<ul class="simple">
<li>An arrow (→) is used to mark grammar productions and can be read as “can consist of.”</li>
<li>Syntactic categories are indicated by <em>italic</em> text and appear on both sides of a grammar production rule.</li>
<li>Literal words and punctuation are indicated by boldface <code class="docutils literal"><span class="pre">constant</span> <span class="pre">width</span></code> text and appear only on the right-hand side of a grammar production rule.</li>
<li>Alternative grammar productions are separated by vertical bars (|). When alternative productions are too long to read easily, they are broken into multiple grammar production rules on new lines.</li>
<li>In a few cases, regular font text is used to describe the right-hand side of a grammar production rule.</li>
<li>Optional syntactic categories and literals are marked by a trailing subscript, <em>opt</em>.</li>
</ul>
<p>As an example, the grammar of a getter-setter block is defined as follows:</p>
<div class="admonition grammar"><p class="first admonition-title">Grammar of a getter-setter block</p><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/getter-setter-block"></a>getter-setter-block</span><span class="arrow"> → </span> <code>{</code> <span class="syntactic-category"><a href="Declarations.html#//appleref/swift/grammar/getter-clause">getter-clause</a></span>  <span class="syntactic-category"><a href="Declarations.html#//appleref/swift/grammar/setter-clause">setter-clause</a></span> <sub>opt</sub> <code>}</code> |  <code>{</code> <span class="syntactic-category"><a href="Declarations.html#//appleref/swift/grammar/setter-clause">setter-clause</a></span>  <span class="syntactic-category"><a href="Declarations.html#//appleref/swift/grammar/getter-clause">getter-clause</a></span>  <code>}</code></p></div></div><p>This definition indicates that a getter-setter block can consist of a getter clause followed by an optional setter clause, enclosed in braces, <em>or</em> a setter clause followed by a getter clause, enclosed in braces. The grammar production above is equivalent to the following two productions, where the alternatives are spelled out explicitly:</p>
<div class="admonition grammar"><p class="first admonition-title">Grammar of a getter-setter block</p><div class="syntax-group"><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/getter-setter-block"></a>getter-setter-block</span><span class="arrow"> → </span> <code>{</code> <span class="syntactic-category"><a href="Declarations.html#//appleref/swift/grammar/getter-clause">getter-clause</a></span>  <span class="syntactic-category"><a href="Declarations.html#//appleref/swift/grammar/setter-clause">setter-clause</a></span> <sub>opt</sub> <code>}</code></p><p class="syntax-def"><span class="syntax-def-name"><a name="//appleref/swift/grammar/getter-setter-block"></a>getter-setter-block</span><span class="arrow"> → </span> <code>{</code> <span class="syntactic-category"><a href="Declarations.html#//appleref/swift/grammar/setter-clause">setter-clause</a></span>  <span class="syntactic-category"><a href="Declarations.html#//appleref/swift/grammar/getter-clause">getter-clause</a></span>  <code>}</code></p></div></div></div>
</div>


    </article>
    <div class="next_previous">
        <p class="previous"><a href="../LanguageGuide/AdvancedOperators.html">Advanced Operators</a></p>
        <p class="next"><a href="LexicalStructure.html">Lexical Structure</a></p>
    </div>

    <div class="admonition-beta admonition">
        <p class="first admonition-title">Beta Software</p>
        <p>
          This documentation contains preliminary information about an API or technology in development.
          This information is subject to change, and software implemented according to this documentation should be tested with final operating system software.
        </p>
        <p class="last"><a class="reference external" href="https://developer.apple.com/support/beta-software/">Learn more about using Apple's beta software</a></p>
    </div>
</main>


<footer role="contentinfo">
  <aside>
    <a href="https://swift.org/atom.xml" title="Subscribe to Site Updates"><i class="feed">Subscribe</i></a>
    <a href="https://twitter.com/swiftlang" rel="nofollow" title="Follow @SwiftLang on Twitter"><i class="twitter">Twitter</i></a>
  </aside>

  <p class="copyright">Copyright &copy; 2018 Apple Inc. All rights reserved.</p>
  <p class="trademark">Swift and the Swift logo are trademarks of Apple Inc.</p>
  <p class="privacy">
    <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
    <a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookies</a>
  </p>
</footer>
<div id="jump_to_overlay"></div>
<script src="../_static/javascripts/application.js"></script>
  </body>
</html>
